(function(global) {
	/**
	 * 省
	 */

	var provinceListKey = "_PROVINCE";
	var cityListKey = "_CITY";
	var zoneListKey = "_ZONE";
	var _loadProvince = function(callback) {
		console.log("_loadProvince");
		mcWebServiceClient.bindList(provinceTableName, null, null, null, null, null, function(data) {
			console.log(data);
			if(data != null) {
				var provinceList = new Array();
				if(data.PAGE_CONTENT != null && data.PAGE_CONTENT.length > 0) {
					for(var index = 0; index < data.PAGE_CONTENT.length; index++) {
						var item = data.PAGE_CONTENT[index];
						var id = item.dictprovince_code;
						var name = item.dictprovince_name;
						var d = {
							id: id,
							name: name
						};
						provinceList.push(d);
					}
				}
				//console.log(provinceList.length);
				//数据持久化
				if(typeof(callback) == "function")
					callback(provinceList);
			}
		}, function(e) {
			//console.log(JSON.stringify(e));
			if(typeof(callback) == "function")
				callback(null);
		});
	};
	var _allProvince = function(callback) {
		if(typeof(callback) != "function")
			throw "callback is not a function";
		//var data = plus.storage.getItem(provinceListKey);
		var data =ui.cache.get(provinceListKey);
		if(data == null||data=="null" || data.length < 1) {
			
			_loadProvince(function(list) {
				if(list!=null&&list.length>0)
				{
					//plus.storage.setItem(provinceListKey, JSON.stringify(list));
					ui.cache.set(provinceListKey, list,5*24*60*60);
				}
				callback(list);
			});
		} else
		{
			//callback(JSON.parse(data));
			callback(data);
		}
	};
	var _getProvinceById = function(id, callback) {
		__allProvince(function(data) {
			if(data == null || data.length < 1)
				callback(null);
			for(var index = 0; index < data.length; index++) {
				var item = data[index];
				if(item.id == id) {
					callback(item);
					break;
				}
			}
		});
	};

	global.provinceManager = {
		all: _allProvince,
		get: _getProvinceById
	};

	/**
	 * 市
	 */

	var _loadCity = function(callback) {
		mcWebServiceClient.bindList(cityTableName, null, null, null, null, null, function(data) {
			if(data != null) {
				var cityList = new Array();
				//console.log(JSON.stringify(data));
				if(data.PAGE_CONTENT != null && data.PAGE_CONTENT.length > 0) {
					for(var index = 0; index < data.PAGE_CONTENT.length; index++) {
						var item = data.PAGE_CONTENT[index];
						var id = item.dictcity_code;
						var name = item.dictcity_name;
						var provinceId = item.provinceId;
						var d = {
							id: id,
							name: name,
							provinceId: provinceId
						};
						cityList.push(d);
					}
				}
				//数据持久化
				//plus.storage.setItem(cityListKey, JSON.stringify(cityList));
				if(typeof(callback) == "function")
					callback(cityList);
			}
		}, function(e) {
			if(typeof(callback) == "function")
				callback();
		});
	};
	var _allCity = function(callback) {
		//var data = plus.storage.getItem(cityListKey);
		var data = ui.cache.get(cityListKey);
		if(data == null||data=="null" || data.length < 1) {
			_loadCity(function(list) {
				
				if(list!=null||list.length>0)
					//plus.storage.setItem(cityListKey, JSON.stringify(list));
					ui.cache.set(cityListKey, list,5*24*60*60);
				callback(list);
			});
		} else
			//callback(JSON.parse(data));
			callback(data);
	};
	var _getCityById = function(id, callback) {
		_allCity(function(data) {
			if(data == null || data.length < 1)
				callback(null);
			for(var index = 0; index < data.length; index++) {
				var item = data[index];
				if(item.id == id) {
					callback(item);
					break;
				}
			}
		});
	};
	var _getCityListByProvinceId=function(id,callback){
		_allCity(function(data) {
			if(data == null || data.length < 1)
				callback(null);
			var list=new Array();
			for(var index = 0; index < data.length; index++) {
				var item = data[index];
				if(item.provinceId == id) {
					list.push(item);
				}
			}
			callback(list);
		});
	};
	global.cityManager = {
		all: _allCity,
		get: _getCityById,
		filter:_getCityListByProvinceId
	};

	/**
	 * 区
	 */
	var _loadZone = function(callback) {
		mcWebServiceClient.bindList(zoneTableName, null, null, null, null, null, function(data) {
			if(data != null) {
				var zoneList = new Array();
				if(data.PAGE_CONTENT != null && data.PAGE_CONTENT.length > 0) {
					for(var index = 0; index < data.PAGE_CONTENT.length; index++) {
						var item = data.PAGE_CONTENT[index];
						var id = item.area_id;
						var name = item.area_name;
						var cityId = item.city_id;
						var provinceId = item.provinceId;

						var d = {
							id: id,
							name: name,
							cityId: cityId,
							provinceId: provinceId
						};
						zoneList.push(d);
					}
				}
				//数据持久化
				//plus.storage.setItem(zoneListKey, JSON.stringify(zoneList));
				if(typeof(callback) == "function")
					callback(zoneList);
			}
		}, function(e) {
			if(typeof(callback) == "function")
				callback();
		});
	};
	var _allZone=function(callback){
		//var data=plus.storage.getItem(zoneListKey);
		var data=ui.cache.get(zoneListKey);
		if(data==null||data.length<1)
		{
			_loadZone(function(list){
				
				if(list!=null&&list.length>0)
					//plus.storage.setItem(zoneListKey, JSON.stringify(list));
					ui.cache.set(zoneListKey, list,5*24*60*60);
				callback(list);
			});
		}
		else
			callback(data);
	};
	var _getZoneById=function(id,callback){
		_allZone(function(data){
			if(data==null||data.length<1)
				callback(null);
			for(var index=0;index<data.length;index++)
			{
				var item=data[index];
				if(item.id==id)
				{
					callback(item);
					break;
				}
			}
		});
	};
	global.zoneManager = {
		all:_allZone,
		get:_getZoneById
	};
})(window);