(function() {
	'use strict';
	
	var _loadDevice = function(callback) {
		nkWebServiceClient.bindList("VideoDvr", "", 1, 0, null, null, function(data) {
				if(data != null) {
					if(data.PAGE_CONTENT != null && data.PAGE_CONTENT.length > 0) {
						callback(data.PAGE_CONTENT);
					} else {
						callback(null);
					}
				} else
					callback(null);
			},
			function(e) {
				ui.alert("监控主机加载失败");
			});
	};
	var _allDevice = function(callback) {
		var cacheKey = "_DVR_"+session.nkid();
		var data = ui.cache.get(cacheKey);
		if(data == null) {
			_loadDevice(function(data) {
				ui.cache.set(cacheKey, data,5*60);
				callback(data);
			});
		} else {
			callback(data);
		}
	};
	var _getDeviceById = function(id, callback) {
		_allDevice(function(data) {
			if(data == null || data.length < 1)
				callback(null);
			for(var idx = 0; idx < data.length; idx++) {
				var item = data[idx];
				if(item.id == id) {
					callback(item);
					break;
				}
			}
		});
	};
	
	window.deviceMgr= {
		all: _allDevice,
		get: _getDeviceById
	};
	/**
	 * 监控主机类型
	 */
	var cacheDeviceCateKey="_DEVICECATE_";
	var cateTimeout=30*60;
	var _loadDeviceCate=function(callback){
		var sqlconds=new SqlConds();
		sqlconds.Add(new SqlCond("tag","=","dvrcate"));
		nkWebServiceClient.bindList("Simplenumber", "", 1, 0,sqlconds, null, function(data) {
				if(data != null) {
					if(data.PAGE_CONTENT != null && data.PAGE_CONTENT.length > 0) {
						callback(data.PAGE_CONTENT);
					} else {
						callback(null);
					}
				} else
					callback(null);
			},
			function(e) {
				ui.alert("监控主机类型加载失败");
			});
	};
	var _allDeviceCate=function(callback){
		var data=ui.cache.get(cacheDeviceCateKey);
		if(data==null)
		{
			_loadDeviceCate(function(data){
				var list=new Array();
				if(data!=null&&data.length>0)
				{
					for(var idx=0;idx<data.length;idx++)
					{
						var item=data[idx];
						list.push({id:item.smp_id,name:item.smp_name,cateId:item.simplecate_id,code:item.smp_expandvalue});
					}
					ui.cache.set(cacheDeviceCateKey,list,cateTimeout);
				}
				callback(list);
			});
		}
		else
			callback(data);
	};
	var _getDeviceCateById=function(id,callback){
		_allDeviceCate(function(data){
			if(data==null||data.length<0)
				callback(null);
			for(var idx=0;idx<data.length;idx++)
			{
				var item=data[idx];
				if(item.id==id)
				{
					callback(item);
					break;
				}
			}
		});
	};
	var _getDeviceCateByCode=function(code,callback){
		_allDeviceCate(function(data){
			if(data==null||data.length<0)
				callback(null);
			for(var idx=0;idx<data.length;idx++)
			{
				var item=data[idx];
				if(item.code==code)
				{
					callback(item);
					break;
				}
			}
		});
	};
	window.deviceCateMgr={
		all:_allDeviceCate,
		get:_getDeviceCateById,
		findByCode:_getDeviceCateByCode
	};
	/**
	 * 监控主机品牌
	 */
	var cacheDeviceTypeKey="_DEVICETYPE_";
	var typeTimeout=30*60;
	var _loadDeviceType=function(callback){
		var sqlconds=new SqlConds();
		sqlconds.Add(new SqlCond("tag","=","dvrtype"));
		nkWebServiceClient.bindList("Simplenumber", "", 1, 0,sqlconds, null, function(data) {
				if(data != null) {
					if(data.PAGE_CONTENT != null && data.PAGE_CONTENT.length > 0) {
						callback(data.PAGE_CONTENT);
					} else {
						callback(null);
					}
				} else
					callback(null);
			},
			function(e) {
				ui.alert("监控主机类型加载失败");
			});
	};
	var _allDeviceType=function(callback){
		var data=ui.cache.get(cacheDeviceTypeKey);
		if(data==null)
		{
			_loadDeviceType(function(data){
				var list=new Array();
				if(data!=null&&data.length>0)
				{
					for(var idx=0;idx<data.length;idx++)
					{
						var item=data[idx];
						//console.log(JSON.stringify(item));
						list.push({id:item.smp_id,name:item.smp_name,cateId:item.simplecate_id,code:item.smp_expandvalue});
					}
				}
				ui.cache.set(cacheDeviceTypeKey,list,typeTimeout);
				callback(list);
			});
		}
		else
			callback(data);
	};
	var _getDeviceTypeById=function(id,callback){
		_allDeviceType(function(data){
			if(data==null||data.length<0)
				callback(null);
			for(var idx=0;idx<data.length;idx++)
			{
				var item=data[idx];
				if(item.id==id)
				{
					callback(item);
					break;
				}
			}
		});
	};
	var _getDeviceTypeByCode=function(code,callback){
		_allDeviceType(function(data){
			if(data==null||data.length<0)
				callback(null);
			for(var idx=0;idx<data.length;idx++)
			{
				var item=data[idx];
				if(item.code==code)
				{
					callback(item);
					break;
				}
			}
		});
	};
	window.deviceTypeMgr={
		all:_allDeviceType,
		get:_getDeviceTypeById,
		findByCode:_getDeviceTypeByCode
	};
	/**
	 * 码流类型
	 */
	var cacheStreamKey="_STREAM_";
	var streamTimeout=30*60;
	var _loadStream=function(callback){
		var sqlconds=new SqlConds();
		sqlconds.Add(new SqlCond("tag","=","stream"));
		nkWebServiceClient.bindList("Simplenumber", "", 1, 0,sqlconds, null, function(data) {
				if(data != null) {
					if(data.PAGE_CONTENT != null && data.PAGE_CONTENT.length > 0) {
						callback(data.PAGE_CONTENT);
					} else {
						callback(null);
					}
				} else
					callback(null);
			},
			function(e) {
				ui.alert("监控主机类型加载失败");
			});
	};
	var _allStream=function(callback){
		var data=ui.cache.get(cacheStreamKey);
		if(data==null)
		{
			_loadStream(function(data){
				var list=new Array();
				if(data!=null&&data.length>0)
				{
					for(var idx=0;idx<data.length;idx++)
					{
						var item=data[idx];
						//console.log(JSON.stringify(item));
						list.push({id:item.smp_id,name:item.smp_name,cateId:item.simplecate_id,code:item.smp_expandvalue});
					}
				}
				ui.cache.set(cacheStreamKey,list,streamTimeout);
				callback(list);
			});
		}
		else
			callback(data);
	};
	var _getStreamById=function(id,callback){
		_allStream(function(data){
			if(data==null||data.length<0)
				callback(null);
			for(var idx=0;idx<data.length;idx++)
			{
				var item=data[idx];
				if(item.id==id)
				{
					callback(item);
					break;
				}
			}
		});
	};
	var _getStreamByCode=function(code,callback){
		_allStream(function(data){
			if(data==null||data.length<0)
				callback(null);
			for(var idx=0;idx<data.length;idx++)
			{
				var item=data[idx];
				if(item.code==code)
				{
					callback(item);
					break;
				}
			}
		});
	};
	window.streamMgr={
		all:_allStream,
		get:_getStreamById,
		findByCode:_getStreamByCode
	};
	/**
	 * 视频服务器
	 */
	var cacheVideoServerKey="_VIDEOSERVER_";
	var videoServerTimeout=30*60;
	var _loadVideoServer=function(callback){
		nkWebServiceClient.bindList("VideoServer", "", 1, 0,null, null, function(data) {
				if(data != null) {
					if(data.PAGE_CONTENT != null && data.PAGE_CONTENT.length > 0) {
						callback(data.PAGE_CONTENT);
					} else {
						callback(null);
					}
				} else
					callback(null);
			},
			function(e) {
				ui.alert("监控主机类型加载失败");
			});
	};
	var _allVideoServer=function(callback){
		var data=ui.cache.get(cacheVideoServerKey);
		if(data==null)
		{
			_loadVideoServer(function(data){
				var list=new Array();
				for(var idx=0;data!=null&&idx<data.length;idx++)
				{
					var item=data[idx];
					list.push({id:item.id,name:item.name});
				}
				ui.cache.set(cacheVideoServerKey,list,videoServerTimeout);
				callback(list);
			});
		}
		else
		{
			callback(data);
		}
	};
	var _getVideoServerById=function(id,callback){
		_allVideoServer(function(data){
			var d=null;
			for(var idx=0;data!=null&&idx<data.length;idx++)
			{
				var item=data[idx];
				if(id==item.id)
				{
					d=item;
					break;
				}
			}
			callback(d);
		});
	};
	window.videoServerMgr={
		all:_allVideoServer,
		get:_getVideoServerById
	};
})();