
/**
 * 加载省
 * @param {Object} callback
 */
ui.loadProvince = function(callback) {
	mcWebServiceClient.bindList(provinceTableName, null, null, null, null, null, function(data) {
		if(data != null) {
			var provinceList = new Array();
			if(data.PAGE_CONTENT != null && data.PAGE_CONTENT.length > 0) {
				for(var index = 0; index < data.PAGE_CONTENT.length; index++) {
					var item = data.PAGE_CONTENT[index];
					var id = item.dictprovince_code;
					var name = item.dictprovince_name;
					var d = {
						id: id,
						name: name
					};
					provinceList.push(d);
				}
			}
			//数据持久化
			plus.storage.setItem(provinceListKey, JSON.stringify(provinceList));
			if(typeof(callback) == "function")
				callback(provinceList);
		}
	}, function(e) {
		ui.alert("数据加载失败！");
		if(typeof(callback) == "function")
			callback();
	});
};
/**
 * 加载市
 */
ui.loadCity = function(callback) {
	mcWebServiceClient.bindList(cityTableName, null, null, null, null, null, function(data) {

		if(data != null) {
			var cityList = new Array();
			//console.log(JSON.stringify(data));
			if(data.PAGE_CONTENT != null && data.PAGE_CONTENT.length > 0) {
				for(var index = 0; index < data.PAGE_CONTENT.length; index++) {
					var item = data.PAGE_CONTENT[index];
					var id = item.dictcity_code;
					var name = item.dictcity_name;
					var provinceId = item.provinceId;
					var d = {
						id: id,
						name: name,
						provinceId: provinceId
					};
					cityList.push(d);
				}
			}
			//数据持久化
			plus.storage.setItem(cityListKey, JSON.stringify(cityList));
			if(typeof(callback) == "function")
				callback(cityList);
		}
	}, function(e) {
		ui.alert("数据加载失败！");
		if(typeof(callback) == "function")
			callback();
	});
};
/**
 * 加载区
 */
ui.loadZone = function(callback) {
	mcWebServiceClient.bindList(zoneTableName, null, null, null, null, null, function(data) {

		if(data != null) {
			var zoneList = new Array();
			//console.log(JSON.stringify(data));
			if(data.PAGE_CONTENT != null && data.PAGE_CONTENT.length > 0) {
				for(var index = 0; index < data.PAGE_CONTENT.length; index++) {
					var item = data.PAGE_CONTENT[index];
					var id = item.area_id;
					var name = item.area_name;
					var cityId = item.city_id;
					var provinceId = item.provinceId;

					var d = {
						id: id,
						name: name,
						cityId: cityId,
						provinceId: provinceId
					};
					zoneList.push(d);
				}
			}
			//数据持久化
			plus.storage.setItem(zoneListKey, JSON.stringify(zoneList));
			if(typeof(callback) == "function")
				callback(zoneList);
		}
	}, function(e) {
		ui.alert("数据加载失败！");
		if(typeof(callback) == "function")
			callback();
	});
};