function mcWebServiceClient(){}
mcWebServiceClient.url="http://www.8huasheng.com:8098/GW_ADMIN-1.0/services/GenericRequestWebService";
//mcWebServiceClient.url="http://192.168.0.45:8080/GW_ADMIN-1.0/services/GenericRequestWebService";
/**
 * 通用接口 doRequest
 * @param {Object} sReqContext
 * @param {Object} sSuccessCallback
 * 成功的回调
 * @param {Object} sFailedCallback
 * 失败时的回调
 * sFailedCallback(e,xml)
 */
mcWebServiceClient.request=function(sReqContext,sSuccessCallback,sFailedCallback){
	var params = new SOAPClientParameters();
	var d=null;
	try
	{
		d=JSON.stringify(sReqContext);
	}
	catch(e){
		return;
	}
    params.add("arg0",d);
    SOAPClient.invoke(mcWebServiceClient.url, "doRequest", params, true, function(response,soapResponse){
    	if(response instanceof Error)
    	{
    		if(typeof(sFailedCallback)=="function")
    		{
    			var e="";//(new XMLSerializer()).serializeToString(soapResponse);
    			sFailedCallback(e,soapResponse);
    		}
    		return;
    	}
    	var data=null;
    	try
    	{
    		data=JSON.parse(response);
    	}
    	catch(e){
    		data=null;
    	}
    	if(typeof(sSuccessCallback)=="function")
    		sSuccessCallback(data);
    	
    },false);
};
/**
 * 通用接口
 * @param {String} fid
 * @param {String} oid
 * @param {Object} param
 * @param {String} sessionId
 * @param {Function} callback
 * @param {Function} error
 */
mcWebServiceClient.get=function(fid,oid,param,sessionId,callback,error){
	var base64="";
	if(param!=null)
		base64=Base64.encode(JSON.stringify(param));
	//console.log("base64="+base64);
	var context=new reqContext();
	context.IO_ID=oid;
	context.DATA_CONTENT=base64;
	context.F_ID=fid;
	context.SESSION_ID=sessionId;
	//console.log(JSON.stringify(context));
	
	mcWebServiceClient.request(context,function(data){
		if(typeof(data)=="object")
		{
			//console.log(JSON.stringify(data));
			if(data.DATA_TYPE=="EXCEPTION")
			{
				//解析返回内容
				var content=Base64.decode(data.DATA_CONTENT);
				//console.log("ex=-"+content);
				var json=null;
				try
				{
					json=JSON.parse(content);
				}
				catch(e){}
				if(typeof(error)=="function")
				{
					error(json);
				}
			}
			else
			{
				//解析返回数据
				var json=null;
				if(data.DATA_CONTENT!=null&&data.DATA_CONTENT.length>0)
				{
					var d=Base64.decode(data.DATA_CONTENT);
					if(data.DATA_TYPE=="OBJECT")
						json=JSON.parse(d);
					else
						json=d;
					//console.log(JSON.stringify(json));
				}
				if(typeof(callback)=="function")
				{
					callback(json);
				}
			}	
		}
	},error);
};
mcWebServiceClient.getString=function(fid,param,callback,error){
	
	//mcWebServiceClient.get(fid,"100",content,)
};
/**
 * 登陆
 * @param {String} sUserId
 * @param {String} sPasswd
 * @param {Function} sCallback JsonObject
 * @param {Function} sErrorCallback
 */
mcWebServiceClient.Login=function(sUserId,sPasswd,sCallback,sErrorCallback){
	var key="CLSoft!@#$%^";
	var data={
		ic:sUserId,
		pwd:TripleDES.encode(sPasswd),
		ip:"127.0.0.1",
		mc:TripleDES.encode("<BaseBoard>NS21156915</BaseBoard><CPU>BFEBFBFF000306C3</CPU>",key,key)
	};
	var json=JSON.stringify(data);
	//console.log(json);
	var base64=Base64.encode(json);
	//console.log("base64="+base64);
	var context=new reqContext();
	context.IO_ID="50";
	context.DATA_CONTENT=base64;
	mcWebServiceClient.request(context,function(data){
		if(typeof(data)=="object")
		{
			if(data.DATA_TYPE=="EXCEPTION")
			{
				//解析返回内容
				var content=Base64.decode(data.DATA_CONTENT);
				var json=null;
				try
				{
					json=JSON.parse(content);
				}
				catch(e){}
				if(typeof(sCallback)=="function")
				{
					sCallback(json);
				}
			}
			else
			{
				//登陆成功
				//解析返回数据
				var d=Base64.decode(data.DATA_CONTENT);
				//console.log(d);
				var agentInfo=JSON.parse(d);
				if(typeof(sCallback)=="function")
				{
					sCallback(agentInfo);
				}
			}
				
		}
	},sErrorCallback);
};
mcWebServiceClient.getAuthorizationList=function(sUserId,sSessionId,sCallback,sErrorCallback){
	var param={};
	if(sUserId!="1"&&sUserId!="clsoft")
	{
		param.agentid=sUserId;
	}
	var base64=Base64.encode(JSON.stringify(param));
	var context=new reqContext();
	context.IO_ID="1602";
	context.DATA_CONTENT=base64;
	context.F_ID="20209";
	context.SESSION_ID=sSessionId;
	mcWebServiceClient.request(context,function(data){
		if(typeof(data)=="object")
		{
			if(data.DATA_TYPE=="EXCEPTION")
			{
				//解析返回内容
				var content=Base64.decode(data.DATA_CONTENT);
				//console.log("ex=-"+content);
				var json=null;
				try
				{
					json=JSON.parse(content);
				}
				catch(e){}
				if(typeof(sErrorCallback)=="function")
				{
					sErrorCallback(json);
				}
			}
			else
			{
				//登陆成功
				//解析返回数据
				var json=null;
				if(data.DATA_CONTENT!=null&&data.DATA_CONTENT.length>0)
				{
					var d=Base64.decode(data.DATA_CONTENT);
					json=JSON.parse(d);
					//console.log(JSON.stringify(json));
				}
				if(typeof(sCallback)=="function")
				{
					sCallback(json);
				}
			}	
		}
	},sErrorCallback);
};

/**
 * 获取表中的数据
 * @param {String} tableName
 * @param {String} colNames
 * @param {Number} pageIndex
 * @param {Number} pageSize
 * @param {SqlConds} sqlConds
 * @param {SqlSorts} sqlSorts
 * @param {Function} callback 成功回调
 * @param {Function} error 失败回调
 */
mcWebServiceClient.bindList=function(tableName,colNames,pageIndex,pageSize,sqlConds,sqlSorts,callback,error){
	var sqlQuery=new SqlQuery();
	//设置表名
	sqlQuery.SetTable(tableName);
	//设置分页
	if(pageIndex!=null&&pageSize!=null)
		sqlQuery.SetPager(pageIndex,pageSize);
	if(sqlConds!=null)
		sqlQuery.AddCond(sqlConds);
	if(sqlSorts!=null)
		sqlQuery.AddOrders(sqlSorts);
	if(colNames!=null&&colNames.length>0)
		sqlQuery.AddColumn(colNames);
	//console.log(JSON.stringify(sqlQuery));
	var param=sqlQuery;//JSON.stringify(sqlQuery);
	mcWebServiceClient.get("","103",param,session.sessionId(),function(data){
		if(typeof(callback)=="function")
			callback(data);
		
	},function(e){
		//console.log("error");
		if(typeof(error)=="function")
			error(e);
	});
	
};
/**
 * 保存数据
 * @param {Object} fid
 * @param {Object} param
 * @param {Object} callback
 * @param {Object} error
 */
mcWebServiceClient.save=function(fid,param,callback,error){
	mcWebServiceClient.get(fid,"100",param,session.sessionId(),function(data){
		if(typeof(callback)=="function")
			callback(data);
		
	},function(e){
		//console.log("error");
		if(typeof(error)=="function")
			error(e);
	});
};
