/**
 * NKTypeManager
 * require:locache.min.js,SqlHelper.js,mcWebServiceClient.js,soapclient.js,const.js,ui.cache.js
 *
 */

(function(global) {
	'use strict';
	var cacheKey="_CACHE_NKTYPE";
	var _load = function(callback) {
		//search cache
			var cond = new SqlCond("cate", "=", session.nkType());
			var sqlConds = new SqlConds();
			sqlConds.Add(cond);
			mcWebServiceClient.bindList(nkTypeTableName, "", 1, 0, sqlConds, null, function(data) {
				if(data != null) {
					var list = new Array();
					if(data.PAGE_CONTENT != null && data.PAGE_CONTENT.length > 0) {
						for(var index = 0; index < data.PAGE_CONTENT.length; index++) {
							var item = data.PAGE_CONTENT[index];
							list.push({
								id: item.id,
								name: item.name,
								tag: item.tag,
								cate: item.cate
							});
						}
						
						if(typeof(callback) == "function")
							callback(list);
					}
				}
			}, function(e) {
				throw e;
			});
		
		
	};
	var _onload=function(typeId,data,callback){
		
		if(data==null||data.length<1)
			callback(null);
		for(var index=0;index<data.length;index++)
		{
			var item=data[index];
			if(item.id==typeId)
			{
				callback(item);
				break;
			}
		}
	};
	/**
	 * 通过类型id获取类型实体
	 * @param {Number} typeId
	 * @param {Function} callback({Object})
	 */
	var get=function(typeId,callback){
		if(typeof(callback)!="function")
			throw "callback is not a function";
		var data = ui.cache.get(cacheKey);
		if(data == null) {
			_load(function(list){
				ui.cache.set(cacheKey, list);
				_onload(typeId,list,callback);
			});
		}
		_onload(typeId,data,callback);
	};
	/**
	 * 获取所有校园类型
	 * @param {Object} callback
	 */
	var all=function(callback){
		if(typeof(callback)!="function")
			throw "callback is not a function";
		var data = ui.cache.get(cacheKey);
		if(data == null) {
			_load(function(list){
				ui.cache.set(cacheKey, list);
				callback(list);
			});
		}
		callback(data);
	};
	global.nkTypeManager={
		all:all,
		get:get
	};
})(window);