if(typeof(ui)=="undefined")
	ui={};
if(typeof(locache)=="undefined")
	throw "ui.cache require locache.min.js";
ui.cache={
	timeout:1*60,
	/**
	 * 设置缓存
	 * @param {String} key
	 * @param {Object} value
	 * @param {Number} timeout 单位：s
	 */
	set:function(key,value,timeout){
		if(typeof(key)=="undefined"||key==null||key.length<1)
			throw "key is null or not defined.";
		var data=value;
		if(typeof(timeout)=="undefined")
			timeout=ui.cache.timeout;
		locache.set(key,value,timeout)
	},
	/**
	 * 获取缓存
	 * @param {String} key
	 */
	get:function(key){
		var data=null;
		if(typeof(key)=="undefined"||key==null||key.length<1)
			return data;
		data=locache.get(key);
		return data;
	},
	/**
	 * 移除缓存
	 * @param {String} key
	 */
	remove:function(key){
		if(typeof(key)=="undefined"||key==null||key.length<1)
			throw "key is null or not defined.";
		locache.remove(key);
	},
	/**
	 * 清空缓存
	 */
	clear:function(){
		locache.flush();
	}
};

